// mipi_header.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>

using std::cin;
using std::cout;

/**
 * Calculate Hamming 30,24 code based on Hamming 72,64 for MIPI packet header's Ecc byte
 **/

int _tmain(int argc, _TCHAR* argv[])
{

	char res;
	char in[20]={0};
	char D0,D1,D2,D3,D4,D5,D6,D7,D8,D9,D10,D11,D12,D13,D14,D15,D16,D17,D18,D19,D20,D21,D22,D23;
	char P0,P1,P2,P3,P4,P5,P6,P7;

	cout <<"Checking Codes(eg.0x1234AF, \"-\" for exit): 0x";
	cin >>in;

	if(in[0]=='-') {
		return 0;
	}

	for(int i=0;i<6;i++){
		if((in[i]>='0') && (in[i]<='9')) {
			in[i] = in[i]-0x30;	
		}else if((in[i]>='A') && (in[i]<='F')){
			in[i] = in[i]-'A'+10;
		}else {
			return 0;
		}
	}

	D0=in[1]&0x01; 	D1=(in[1]&0x02)>>1; 	
	D2=(in[1]&0x04)>>2; 	D3=(in[1]&0x08)>>3;

	D4=in[0]&0x01; 	D5=(in[0]&0x02)>>1; 	
	D6=(in[0]&0x04)>>2; 	D7=(in[0]&0x08)>>3;

	D8=in[3]&0x01; 	D9=(in[3]&0x02)>>1;	
	D10=(in[3]&0x04)>>2;	D11=(in[3]&0x08)>>3;

	D12=in[2]&0x01;	D13=(in[2]&0x02)>>1;	
	D14=(in[2]&0x04)>>2;	D15=(in[2]&0x08)>>3;

	D16=in[5]&0x01;	D17=(in[5]&0x02)>>1;	
	D18=(in[5]&0x04)>>2;	D19=(in[5]&0x08)>>3;

	D20=in[4]&0x01;	D21=(in[4]&0x02)>>1;	
	D22=(in[4]&0x04)>>2;	D23=(in[4]&0x08)>>3;
	
	P7=0;
	P6=0;
	P5=D10^D11^D12^D13^D14^D15^D16^D17^D18^D19^D21^D22^D23;
	P4=D4^D5^D6^D7^D8^D9^D16^D17^D18^D19^D20^D22^D23;
	P3=D1^D2^D3^D7^D8^D9^D13^D14^D15^D19^D20^D21^D23;
	P2=D0^D2^D3^D5^D6^D9^D11^D12^D15^D18^D20^D21^D22;
	P1=D0^D1^D3^D4^D6^D8^D10^D12^D14^D17^D20^D21^D22^D23;
	P0=D0^D1^D2^D4^D5^D7^D10^D11^D13^D16^D20^D21^D22^D23;

	res = ((P7&0x01)*8+(P6&0x01)*4+(P5&0x01)*2+(P4&0x01))*16+(P3&0x01)*8+(P2&0x01)*4+(P1&0x01)*2+(P0&0x01);  
	printf("Result:0x%02X\r\n",res);
	return 0;
}

